/*
 * loader.c
 *
 * Copyright 2007, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 *
 * st@C[h
 */


#include <sys/config.h>
#include <sys/types.h>
#include <sys/param.h>
#include <kern/fs.h>
#include <kern/elf.h>
#include <kern/shell.h>

#include <kern/test.h>
#include <kern/debug.h>


//#define DEBUG_LOADER 1
#ifdef DEBUG_LOADER
	#define STATIC
	#define INLINE
#else
	#define STATIC	static
	#define INLINE	inline
#endif


//================================== ʒ` ===========================================

//================================== O[oC|[g ===============================

//================================== PRIVATE ============================================

//================================== PROTECTED ==========================================

//================================== PUBLIC =============================================

/*
 * t@CpX^XN[h\bh擾Ẵ\bhĂяoB
 * return : error number
 */
int loadFile(
	const char *path,		// st@CpX
	char **argv,
	char **envp,
	uint *o_entryAddr,		// X^bNJnjAAhX
	uint *o_stackAddr)		// sJnjAAhX
{
	EXEC_FD fd;
	int error;

	error = exec_open(path, &fd);
	if (error != NOERR) {
		return error;
	}

	/* ELFoCĩ[hB */
	for (;;) {
		error = loadElf(&fd, argv, envp, o_entryAddr, o_stackAddr);
		if (error != -ENOEXEC) {
			break;
		}
		error = loadShell(&fd, path, argv, envp, o_entryAddr, o_stackAddr);
		if (error != -ENOEXEC) {
			break;
		}
		
		error = -ENOEXEC;
		break;
	}

	/* t@C̃N[Y */
	exec_close(&fd);

	return error;
}
